import { buildRequestParams } from "./../helpers/index.mjs";
import { useRuntimeConfig } from "#imports";
function getEndpoint(operation, operationName) {
  const config = useRuntimeConfig();
  return `${config?.public?.["nuxt-graphql-middleware"]?.serverApiPrefix}/${operation}/${operationName}`;
}
const state = {
  fetchOptions: {}
};
export const useGraphqlState = () => {
  return state;
};
export function useGraphqlQuery(...args) {
  const [name, variables, fetchOptions = {}] = typeof args[0] === "string" ? [args[0], args[1]] : [args[0].name, args[0].variables, args[0].fetchOptions];
  const state2 = useGraphqlState();
  return $fetch(getEndpoint("query", name), {
    params: buildRequestParams(variables),
    // @todo: Remove any once https://github.com/unjs/nitro/pull/883 is released.
    ...state2.fetchOptions,
    ...fetchOptions
  }).then((v) => {
    return {
      data: v.data,
      errors: v.errors || []
    };
  });
}
export function useGraphqlMutation(...args) {
  const [name, variables, fetchOptions = {}] = typeof args[0] === "string" ? [args[0], args[1]] : [args[0].name, args[0].variables, args[0].fetchOptions];
  const state2 = useGraphqlState();
  return $fetch(getEndpoint("mutation", name), {
    // @todo: Remove any once https://github.com/unjs/nitro/pull/883 is released.
    method: "post",
    body: variables,
    ...state2.fetchOptions,
    ...fetchOptions
  }).then((v) => {
    console.log(v);
    return {
      data: v.data,
      errors: v.errors || []
    };
  });
}
