import { QueryObject } from 'ufo';
import type { H3Event } from 'h3';
import type { FetchOptions, FetchResponse, FetchError } from 'ofetch';
import type { GraphqlMiddlewareRuntimeConfig, GraphqlMiddlewareServerOptions } from './../../../types';
import { GraphqlMiddlewareOperation } from './../../settings';
export declare function queryParamToVariables(query: QueryObject): any;
/**
 * Get the URL of the GraphQL endpoint.
 */
export declare function getEndpoint(config: GraphqlMiddlewareRuntimeConfig, serverOptions: GraphqlMiddlewareServerOptions, event: H3Event, operation: GraphqlMiddlewareOperation, operationName: string): string | Promise<string>;
/**
 * Get the options for the $fetch request to the GraphQL server.
 */
export declare function getFetchOptions(serverOptions: GraphqlMiddlewareServerOptions, event: H3Event, operation: GraphqlMiddlewareOperation, operationName: string): FetchOptions | Promise<FetchOptions>;
/**
 * Assure that the request is valid.
 */
export declare function validateRequest(method?: string, operation?: GraphqlMiddlewareOperation, name?: string, documents?: Record<string, Record<string, string>>): void;
/**
 * Handle GraphQL server response.
 */
export declare function onServerResponse(serverOptions: GraphqlMiddlewareServerOptions, event: H3Event, response: FetchResponse<any>, operation?: string, operationName?: string): any;
/**
 * Handle GraphQL server errors.
 */
export declare function onServerError(serverOptions: GraphqlMiddlewareServerOptions, event: H3Event, error: FetchError, operation?: string, operationName?: string): any;
